#!/bin/sh
#
# Unpack the needed Python libs and compile them

cd lib
tar xzf gensim-0.8.6.tar.gz
tar xzf numpy-1.7.1.tar.gz
tar xzf scipy-0.12.0.tar.gz

cd numpy-1.7.1
python setup.py install --user
if [ "$?" = "0" ]
then
    echo "numpy installed"
else
    echo "numpy install failed, you need to do this manually"
    exit 1
fi

cd ../scipy-0.12.0
python setup.py install --user
if [ "$?" = "0" ]
then
    echo "scipy installed"
else
    echo "scipy install failed, you need to do this manually"
    exit 1
fi

echo "Python libraries successfully installed in your home directory"
exit 0
